---
include:
  - remote: 'https://gitlab.com/op_so/projects/gitlab-ci-templates/-/raw/main/templates/lint.gitlab-ci.yml'
  - remote: 'https://gitlab.com/op_so/projects/gitlab-ci-templates/-/raw/main/templates/image-factory.gitlab-ci.yml'

variables:
  DOCKER_REGISTRY_IMAGE_TAG: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHORT_SHA
  DOCKER_DOCKERHUB_IMAGE_REPOSITORY: index.docker.io/jfxs/opentofu-inventory
  DOCKER_DOCKERHUB_RM_URL: jfxs/opentofu-inventory
  DOCKER_QUAY_IMAGE_REPOSITORY: quay.io/ifxs/opentofu-inventory
  DOCKER_QUAY_RM_URL: quay.io/ifxs/opentofu-inventory
  DOCKER_SBOM_SUBSET: "^github.com/go-task/task/v3 |^ca-certificates |^curl |^git |^jq |^python3 |^state2inventory "
  LINT_DOCKER: "true"
  LINT_SHELL: "true"
  LINT_SHELL_FILE: "files/*.sh"
  LINT_VALE: "true"
  TASKFILE_VERSION: .Taskfile-version.yml

stages:
  - lint
  - build-image
  - test-image
  - trigger-publish-image
  - publish-image

docker:build:
  before_script:
    - apk --no-cache add ca-certificates curl
    - if [ ! -f "$TASKFILE_VERSION" ]; then wget -q -O "$TASKFILE_VERSION" https://gitlab.com/op_so/task/task-templates/-/raw/main/Taskfile.d/version.yml; fi
    - OT_VERSION=$(task --taskfile "$TASKFILE_VERSION" get-latest-github R=opentofu/opentofu)
    - echo "opentofu version >${OT_VERSION}<"
    - task 00:20-download-opentofu OT_VERSION=$OT_VERSION
    - DOCKER_BUILD_VERSION=$OT_VERSION

sanity-test:amd64:
  image: $DOCKER_REGISTRY_IMAGE_TAG
  stage: test-image
  script:
    - tofu version
    - state2inventory --version
    - state2inventory terraform --help

sanity-test:arm64:
  extends: sanity-test:amd64
  tags:
    - arm64

sanity-test:version:
  before_script:
    - if [ ! -f "$TASKFILE_VERSION" ]; then wget -q -O "$TASKFILE_VERSION" https://gitlab.com/op_so/task/task-templates/-/raw/main/Taskfile.d/version.yml; fi
    - DOCKER_VERSION_CLI=$(task --taskfile "$TASKFILE_VERSION" get-docker-cli-version IMG="$DOCKER_REGISTRY_IMAGE_TAG" CMD="tofu version")
